
/* 
fBot
Copyright (c) 2024 Fabian Freitag
Licensed under the MIT license
www.fbnfrtg.de
*/

jQuery(document).ready(function($) {

var fbotjsurl = $('script[src*="/fbot.js"]').attr('src');
let fboturl = fbotjsurl.replace("fbot.js", "");

var welcomemessage = 'Hallo. Wie kann ich dir helfen?';

var ts = Date.now();

var cssFile = document.createElement("link");
cssFile.rel = "stylesheet";
cssFile.type = "text/css";
cssFile.href = fboturl+"/fbot.css?"+ts;
document.head.appendChild(cssFile);

initializeChatbot();
  
function aktuelleUhrzeit() {
    const jetzt = new Date();
    let stunden = jetzt.getHours();
    let minuten = jetzt.getMinutes();
  
    if (minuten < 10) {
      minuten = '0' + minuten;
    }
  
    return stunden + ':' + minuten;
}
  
function generateUniqueId() {
    const timestamp = Date.now().toString(36); 
    const randomStr = Math.random().toString(36).substr(2, 5); 
    return `${timestamp}-${randomStr}`;
}

function initnewchat(){

    var uhrzeit = aktuelleUhrzeit();

    setTimeout(() => {

        var currentmessage = '<div class="chat-box-body-send fp"><p>'+welcomemessage+'</p><span>'+uhrzeit+'</span></div>';
        $('.chat-box-body').append(currentmessage).hide().show().children(':last').removeClass('fp');

        var oldmessages = localStorage.getItem("chatlog");
        localStorage.setItem("chatlog", oldmessages + currentmessage);

     }, "1000");
}

function initializeChatbot(){

    $('body').append('<div class="chat-box"><div class="chat-box-header"><h3></h3><div class="closechatbox"><svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="#000000" class="bi bi-x-lg" viewBox="0 0 16 16"><path d="M2.146 2.854a.5.5 0 1 1 .708-.708L8 7.293l5.146-5.147a.5.5 0 0 1 .708.708L8.707 8l5.147 5.146a.5.5 0 0 1-.708.708L8 8.707l-5.146 5.147a.5.5 0 0 1-.708-.708L7.293 8z"/></svg></div></div><div class="chat-box-body"></div><div class="chat-box-footer"><input placeholder="Deine Frage" type="text" id="message" /><div class="send"><svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="#999" class="bi bi-send" viewBox="0 0 16 16"><path d="M15.854.146a.5.5 0 0 1 .11.54l-5.819 14.547a.75.75 0 0 1-1.329.124l-3.178-4.995L.643 7.184a.75.75 0 0 1 .124-1.33L15.314.037a.5.5 0 0 1 .54.11ZM6.636 10.07l2.761 4.338L14.13 2.576zm6.787-8.201L1.591 6.602l4.339 2.76 7.494-7.493Z"/></svg></div></div></div><div class="chat-button active"><svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" fill="#fff" class="bi bi-chat-fill" viewBox="0 0 16 16"><path d="M8 15c4.418 0 8-3.134 8-7s-3.582-7-8-7-8 3.134-8 7c0 1.76.743 3.37 1.97 4.6-.097 1.016-.417 2.13-.771 2.966-.079.186.074.394.273.362 2.256-.37 3.597-.938 4.18-1.234A9.06 9.06 0 0 0 8 15"/></svg></div>');

    if (localStorage.getItem("chatlog") !== null) {
        var chatlog = localStorage.getItem("chatlog");
        setTimeout(() => {
            $('.chat-box-body').append(chatlog);
         }, "200");

         setTimeout(() => {
            $('.chat-box-body').children().removeClass('fp');
            $('.chat-box-body').animate({scrollTop: $('.chat-box-body').prop("scrollHeight")}, 'slow');
         }, "300");   

    } else {
        var initialchatlog = " ";
        localStorage.setItem("chatlog", initialchatlog);

        var uniqueId = generateUniqueId();
        localStorage.setItem("chatid", uniqueId);

    }

    $('.chat-button').on('click', function() {
        $('.chat-button').removeClass('active');
        $('.chat-box').addClass('active');
        $('body').toggleClass('noscroll');

        if ($(window).width() > 768) {
            $('#message').focus();
        }      

        var uhrzeit = aktuelleUhrzeit();

        if ($('.chat-box-body').children().length == 0){
            initnewchat();
        }      
 
    });

    $('.chat-box .chat-box-header .closechatbox').on('click', function() {
        $('.chat-button').addClass('active');
        $('.chat-box').removeClass('active');
        $('body').toggleClass('noscroll');

    });

    $('.send').on('click', function() {
        sendmessage();
    });

    $('#message').keypress(function(e){
        if (e.which == 13){
            sendmessage();
        }
    });

}


function sendmessage(){
    
    var message = $('#message').val();

    if (message){

    var uhrzeit = aktuelleUhrzeit();

    var currentmessage = '<div class="chat-box-body-receive fp"><p>'+message+'</p><span>'+uhrzeit+'</span></div>';

    var oldmessages = localStorage.getItem("chatlog");
    localStorage.setItem("chatlog", oldmessages + currentmessage);

    $('.chat-box-body').append(currentmessage).hide().show().children(':last').removeClass('fp');;
    $('#message').val('');
    setTimeout(() => {
        $('.chat-box-body').animate({scrollTop: $('.chat-box-body').prop("scrollHeight")}, 500);
    }, "150");

    var chatid = localStorage.getItem("chatid");

    $.post(fboturl+"/fbot.php",{

        chatid: chatid,
        message: message,

    }, function(response){

        var uhrzeit = aktuelleUhrzeit();

        if (response == 'chat_loeschen'){

            var currentmessage = '<div class="chat-box-body-send fp"><p>OK, der Chat wird gelöscht.</p><span>'+uhrzeit+'</span></div>';

            setTimeout(() => {
                $('.chat-box-body').append(currentmessage).hide().show();
            }, "700");

            setTimeout(() => {
                $('.chat-box-body').children(':last').removeClass('fp');
                $('.chat-box-body').animate({scrollTop: $('.chat-box-body').prop("scrollHeight")}, 'slow');
            }, "750");

            setTimeout(() => {
                $('.chat-box-body').children().remove();
                localStorage.setItem("chatlog", '');

                var uniqueId = generateUniqueId();
                localStorage.setItem("chatid", uniqueId);

            }, "1750");

            setTimeout(() => {
                var currentmessage = '<div class="chat-box-body-send fp"><p>'+welcomemessage+'</p><span>'+uhrzeit+'</span></div>';
                $('.chat-box-body').append(currentmessage).hide().show().children(':last').removeClass('fp');
                var oldmessages = localStorage.getItem("chatlog");
                localStorage.setItem("chatlog", oldmessages + currentmessage);
            }, "2500");

            
        var oldmessages = localStorage.getItem("chatlog");
        localStorage.setItem("chatlog", oldmessages + currentmessage);

        } else {

            var uhrzeit = aktuelleUhrzeit();

            var currentmessage = '<div class="chat-box-body-send fp"><p>'+response+'</p><span>'+uhrzeit+'</span></div>';

            setTimeout(() => {
                $('.chat-box-body').append(currentmessage).hide().show();
            }, "700");

            setTimeout(() => {
                $('.chat-box-body').children(':last').removeClass('fp');
                $('.chat-box-body').animate({scrollTop: $('.chat-box-body').prop("scrollHeight")}, 'slow');
            }, "750");

            var oldmessages = localStorage.getItem("chatlog");
            localStorage.setItem("chatlog", oldmessages + currentmessage);
        }
    });
    }   

}

});